// naumann@stce.rwth-aachen.de

#include <Eigen/Dense>
#include <iostream>
using namespace std;

template<typename T>
using VT=Eigen::VectorX<T>;

template<typename T>
using MT=Eigen::MatrixX<T>;

template<typename T>
VT<T> Householder(VT<T> x) {
  int m=x.size();
  cout << "x^T=" << x.transpose() << endl;
  // v
  VT<T> v=x-x.norm()*VT<T>::Unit(m,0); 
  cout << "v^T=(x-||x||*e_0)^T=" << v.transpose() << endl;
  // v_half
  VT<T> v_half=v*(x.transpose()*v/v.norm());
  cout << "v^T*((x^T*v)/||v||)=" << v_half.transpose() << endl;
  // explicit computation to be avoided
  MT<T> H=MT<T>::Identity(m,m)-2*v*v.transpose()/v.dot(v);
  cout << "H=" << endl << H << endl;
  return H*x;
}

int main() {
  int m=2; 
  using T=double;
  VT<T> x(m);
  x(0)=2; x(1)=1;
  cout << "x^T=" << x.transpose() << endl;
  cout << "||x||=" << x.norm() << endl;
  x=Householder(x);
  cout << "x^T=(H*x)^T=" << x.transpose() << endl; 
  return 0;
}
