// naumann@stce.rwth-aachen.de

#include <Eigen/Dense>

#include <iostream>
#include <cmath>
using namespace std;

using VT=Eigen::VectorX<double>;

// slopes of linear functions and lengths at points
// of intersection with v(1) and w(1), respectively
void plot(VT v, VT w) {
  cout << "set size square; plot [-1:1] [-1:1] "
       << v(1) << '/' << v(0) << "*x, " << v(1) << ", "
       << w(1) << '/' << w(0) << "*x, " << w(1) << endl;
}

int main() {
  int n=2;
  // two random vectors in R^2
  VT v=VT::Random(n), w=VT::Random(n);
  plot(v,w);
  // radians to degrees
  cout << (45/atan(1.))*acos(v.dot(w)/(v.norm()*w.norm())) << endl;
  return 0;
}
